(function() {
  var BufferStream, pipe, render, streamify;

  BufferStream = require('bufferstream');

  streamify = require('dt-stream');

  pipe = function(template, stream) {
    return streamify(template, {
      stream: stream
    }).stream.once('close', function() {
      return template.remove();
    });
  };

  render = function(template, stream) {
    return pipe(template, stream != null ? stream : new BufferStream({
      encoding: 'utf-8',
      size: 'flexible',
      disabled: true
    }));
  };

  module.exports = render;

  module.exports.render = render;

  module.exports.pipe = pipe;

}).call(this);
