(function() {
  var __slice = [].slice;

  exports.addClass = function() {
    var classes, cls, tag, tagclass, _i, _len, _ref;

    tag = arguments[0], classes = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
    if (!(tag != null ? tag.attr : void 0)) {
      return;
    }
    tagclass = (_ref = tag.attr('class')) != null ? _ref : "";
    for (_i = 0, _len = classes.length; _i < _len; _i++) {
      cls = classes[_i];
      if (!new RegExp(cls).test(tagclass)) {
        tagclass = "" + cls + " " + tagclass;
      }
    }
    return tag.attr('class', tagclass.replace(/\s\s/g, " "));
  };

  exports.removeClass = function() {
    var classes, cls, tag, tagclass, _i, _len, _ref;

    tag = arguments[0], classes = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
    if (!(tag != null ? tag.attr : void 0)) {
      return;
    }
    tagclass = (_ref = tag.attr('class')) != null ? _ref : "";
    for (_i = 0, _len = classes.length; _i < _len; _i++) {
      cls = classes[_i];
      if (new RegExp(cls).test(tagclass)) {
        tagclass = tagclass.replace(cls, "");
      }
    }
    return tag.attr('class', tagclass);
  };

  exports.compose = function() {
    var functions;

    functions = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    if (functions.length === 1 && Array.isArray(functions[0])) {
      functions = functions[0];
    }
    return function() {
      var args, fun, _i, _len;

      args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      for (_i = 0, _len = functions.length; _i < _len; _i++) {
        fun = functions[_i];
        fun.apply(this, args);
      }
      return this;
    };
  };

  exports.partialize = function() {
    var moargs, partial;

    partial = arguments[0], moargs = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
    return function() {
      var args;

      args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      return this.partial(partial.call.apply(partial, [this].concat(__slice.call(moargs), __slice.call(args))));
    };
  };

}).call(this);
